--- old/usr/src/cmd/newtask/newtask.c	Mon Mar 25 12:53:25 2013
+++ new/usr/src/cmd/newtask/newtask.c	Mon Mar 25 12:53:25 2013
@@ -20,12 +20,12 @@
  * CDDL HEADER END
  */
 /*
+ * Copyright (c) 2013 Gary Mills
+ *
  * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/types.h>
 #include <sys/task.h>
 
@@ -46,6 +46,12 @@
 #include <signal.h>
 #include <priv_utils.h>
 
+#ifdef	LOGNAME_MAX_ILLUMOS
+#define	_LOGNAME_MAX	LOGNAME_MAX_ILLUMOS
+#else /* LOGNAME_MAX_ILLUMOS */
+#define	_LOGNAME_MAX	LOGNAME_MAX
+#endif /* LOGNAME_MAX_ILLUMOS */
+
 #include "utils.h"
 
 #define	OPTIONS_STRING	"Fc:lp:v"
@@ -654,7 +660,7 @@
 static struct passwd *
 match_user(uid_t uid, char *projname, int is_my_uid)
 {
-	char prbuf[PROJECT_BUFSZ], username[LOGNAME_MAX+1];
+	char prbuf[PROJECT_BUFSZ], username[_LOGNAME_MAX+1];
 	struct project prj;
 	char *tmp_name;
 	struct passwd *pw = NULL;
@@ -696,7 +702,8 @@
 	if (projname == NULL || getuid() == (uid_t)0)
 		return (pw);
 
-	(void) strcpy(username, pw->pw_name);
+	(void) strncpy(username, pw->pw_name, sizeof (username) - 1);
+	username[sizeof (username) - 1] = '\0';
 
 	if (inproj(username, projname, prbuf, PROJECT_BUFSZ) == 0) {
 		char **u;
